/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	NavigateBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.xml.transform.stream.StreamResult;

import jp.co.ntt.lms.lo.scorm.cbtcom.CMIUtil;
import jp.co.ntt.lms.lo.util.UserIDFolder;
import jp.co.ntt.lms.lo.scorm.kernel.SCORMCommunicationModule;
import jp.co.ntt.lms.lo.scorm.kernel.Activity;
import jp.co.ntt.lms.lo.scorm.kernel.exception.SequencingException;
import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

import org.w3c.dom.Document;

/**
 *	NavigateBusinessAction クラス<br>
 *	navigationコマンドを受け付けるクラス<br>
 */
public class NavigateBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public NavigateBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * navigation要求受付処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// 起動パラメータをsessionから取得する
			ExecuteParameters executeParameters = (ExecuteParameters)session.getAttribute("SCORM.EXECUTE_PARAMETERS");

			// sessionから取得できなかった場合 → Session Timeout 発生時
			if (executeParameters == null) {
				xmsResponse.setBusinessStatus("SessionTimeout");
				return;
			}

			// sessionからapi adapterを取得する
			SCORMAPIAdapter apiAdapter = (SCORMAPIAdapter)session.getAttribute("SCORM.API_ADAPTER");

			// sessionから取得できなかった場合 → Session Timeout 発生時
			if (apiAdapter == null) {
				xmsResponse.setBusinessStatus("SessionTimeout");
				return;
			}

			// エンジンをapplicationから取得する
			String engineKeyName =
				"SCORM." + executeParameters.getUserID() + "." + executeParameters.getLOID() + ".ENGINE";

			Engine engine = (Engine)application.getAttribute(engineKeyName);

			// applicationから取得できなかった場合 → 既に教材が終了している場合 → Session Timeoutに見せる
			if (engine == null) {
				xmsResponse.setBusinessStatus("SessionTimeout");
				return;
			}

			// ナビゲーションコマンドを取得する
			String command = xmsRequest.getParameter("Command");

			if (apiAdapter.getCommunicationModule() != null) {
				// "cmi.exit"の値を取得する
				String exitStatus = apiAdapter.getCommunicationModule().getValue("cmi.exit");

				if (exitStatus != null) {
					// "cmi.exit"の値が"time-out"の場合は、ExitAllを実行する
					if (exitStatus.equals("time-out")) {
						command = "ExitAll";
					}
					// "cmi.exit"の値が"logout"の場合は、SuspendAllを実行する
					else if (exitStatus.equals("logout")) {
						command = "SuspendAll";
					}
				}

			}

			boolean result;
			StringBuffer SCOURL = null;

			try {
				// エンジンにナビゲーション要求を行う
				result = engine.navigate(command, xmsRequest.getParameter("ActivityID"));

				// 正常終了した場合は、シーケンシング例外をクリアする
				engine.setLastSequencingException(null);

				// 「学習継続可能」な場合
				if (result) {
					// カレントアクティビティが存在するかどうかチェックする
					if (engine.getCurrentActivity() != null) {
						int attemptCount = 0;

						if (engine.getCurrentActivity().getActivityProgressStatus()) {
							attemptCount = engine.getCurrentActivity().getActivityAttemptCount();
						}

						// AICCログの格納フォルダを作成する
						StringBuffer learningLogFolder = new StringBuffer();

						learningLogFolder.append(userIDPath(SG.get("LearningLogBaseURL"), executeParameters.getUserID()));
						learningLogFolder.append(File.separator);
						learningLogFolder.append(executeParameters.getLOID());
						learningLogFolder.append(File.separator);
						learningLogFolder.append(executeParameters.getStudySessionCount());
						learningLogFolder.append(File.separator);
						learningLogFolder.append(executeParameters.getLaunchCount());
						learningLogFolder.append(File.separator);
						learningLogFolder.append(engine.getCurrentActivity().getIdentifier());
						learningLogFolder.append(File.separator);
						learningLogFolder.append(new DecimalFormat("0000000000").format(attemptCount));
						learningLogFolder.append(File.separator);
						learningLogFolder.append(new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()));
						learningLogFolder.append(File.separator);

						// (次)SCOへのURLを取得する
						String nextSCOURL = engine.getURL(learningLogFolder.toString());

						// (次)SCOのURLが取得できた場合
						// 2010.10.15 taku-harada mod >>
//						if (nextSCOURL != null) {
//							SCOURL = new StringBuffer();
//							SCOURL.append(SG.get("SystemBaseURL"));
//							SCOURL.append("contents/");
//							SCOURL.append(executeParameters.getManifestID());
//							SCOURL.append("/");
//							SCOURL.append(nextSCOURL);
//						}
						if (nextSCOURL != null) {
							SCOURL = new StringBuffer();
							if(nextSCOURL.startsWith("http://") || nextSCOURL.startsWith("https://")){
								SCOURL.append(nextSCOURL);
							}else{
								SCOURL = new StringBuffer();
								SCOURL.append(SG.get("SystemBaseURL"));
								SCOURL.append("contents/");
								SCOURL.append(executeParameters.getManifestID());
								SCOURL.append("/");
								SCOURL.append(nextSCOURL);								
							}
						}
						// 2010.10.15 taku-harada mod <<

						// api adapterをカレントアクティビティのapi adapterに変更する
						apiAdapter.setCommunicationModule(engine.getCommunicationModule());
					}
				}
			}
			catch (SequencingException ex) {
				Debug.write(ex);

				// シーケンシング例外が発生した場合
				result = true;
				engine.setLastSequencingException(ex);
			}

			Document traceLog = engine.getTraceLog();

			// トレースログが存在する場合
			if (traceLog != null) {
				// トレースログのフルパス名を作成する
				StringBuffer navtraceLogFile = new StringBuffer();

				navtraceLogFile.append(userIDPath(SG.get("ResumeDataBaseURL"), executeParameters.getUserID()));
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getLOID());
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getStudySessionCount());
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getLaunchCount());
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append("navtrace.xml");

				// トレースログを「追加モード」でオープンする
				BufferedOutputStream bos =
					new BufferedOutputStream(new FileOutputStream(navtraceLogFile.toString(), true));

				try {
					// navtrace.xmlにトレースログを追加する
					XMLUtil.output(traceLog.getDocumentElement(), true, SG.get("XMLEncoding"), new StreamResult(bos));
				}
				finally {
					bos.close();
				}
			}

			// 「学習中断」もしくは「学習完了」の場合
			if (!result) {
				// api adapterを未設定状態に設定する
				apiAdapter.setCommunicationModule(null);

				// root activityを取得する
				Activity rootActivity = engine.getRootActivity();
				String exitResult;

				// activty is suspended の場合は中断("SuspendAll"が実行された)
				if (rootActivity.isSuspended() && !command.equals("ExitAll")) {
					exitResult = "SUSPEND";
				}
				// activty is suspended でない場合は終了(正常に教材の学習が終了した、もしくは"ExitAll"が実行された)
				else {
					exitResult = "EXIT";
				}

				// 中断情報をXMSⅡへ送信する
				Exception error = null;

				synchronized (engine) {
					try {
						// 中断処理を実行し、中断情報をXMSⅡへ送信する
						engine.discontinue(exitResult, false);
					}
					catch (Exception ex) {
						Debug.write(ex);

						error = ex;
					}

					// エンジンをapplicationから削除する
					application.removeAttribute(engineKeyName);
				}

				// session情報を削除する
				session.removeAttribute("SCORM.TIMEOUT_WATCHER");
				session.removeAttribute("SCORM.EXECUTE_PARAMETERS");
				session.removeAttribute("SCORM.API_ADAPTER");

				// 中断処理中に例外が発生しなかった場合
				if (error == null) {
					EndLearningBusinessBean elbb = new EndLearningBusinessBean(executeParameters);
					elbb.setExitResult(exitResult);

					xmsResponse.setBusinessBean(elbb);
					xmsResponse.setBusinessStatus("EndLearning");
				}
				// 中断処理中に例外が発生した場合
				else {
					LearningLogSendErrorBusinessBean llsebb = new LearningLogSendErrorBusinessBean(executeParameters);
					llsebb.setException(error);

					xmsResponse.setBusinessBean(llsebb);
					xmsResponse.setBusinessStatus("LearningLogSendError");
				}

				return;
			}

			NavigateBusinessBean navigateBusinessBean = new NavigateBusinessBean(executeParameters);

			navigateBusinessBean.setSCOURL((SCOURL == null) ? null : SCOURL.toString());
			
			// 2011.09.01 taku-harada add >>
			// AICC_URLとAICC_SIDを個別に受け渡すように変更
			SCORMCommunicationModule comuModule = apiAdapter.getCommunicationModule();
			if (comuModule != null) {
				String aicc_url = comuModule.getValue("cmi.launch.aicc_url");
				navigateBusinessBean.setAICC_URL(CMIUtil.urlEncode(aicc_url));
				String aicc_sid = comuModule.getValue("cmi.launch.aicc_sid");
				navigateBusinessBean.setAICC_SID(CMIUtil.urlEncode(aicc_sid));
			}
			// 2011.09.01 taku-harada add <<

			xmsResponse.setBusinessBean(navigateBusinessBean);
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}

	private static String userIDPath(String strDirPath, String strUserID)
	{
		return UserIDFolder.getPath(strDirPath, strUserID);
	}
}
